// profiling tool
//
#ifdef RUNTIME_PROFILE

#define MAX_TIMER 10

class ProfileInfo {
   // record the profiling level
  int mode;
  char   name[30];       // hostname
  double comm;
  double io_r, io_w;
  double aio_r;
  double send, recv;
  double remap_time;
  int    remap_count;
  double time[MAX_TIMER];
  int  n;
public:
  ProfileInfo();
  void StartProfile(int mode_);
  void EndProfile();
  void setMode(int mode_);
  int  getMode();
  long timer(int num);
  void pushTime();
  double popTime();
  void BeginSend();
  void EndSend();
  void BeginRecv();
  void EndRecv();
  void BeginRead();
  void EndRead();
  void BeginARead();
  void EndARead();
  void BeginWrite();
  void EndWrite();
  // level 1
  void BeginRemap();
  void EndRemap();
  void display();
} ;


extern ProfileInfo  *Prof;

extern unsigned int read_ops, write_ops;
extern double         bytes_read, bytes_write;  
extern unsigned int  seiving, nonseiving;


#define ProfInit()       Prof = new ProfileInfo;
#define ProfBegin(m)      Prof->StartProfile(m);
#define ProfEnd()        Prof->EndProfile();
#define ProfBeginSend()  Prof->BeginSend();
#define ProfEndSend()    Prof->EndSend();
#define ProfBeginRecv()  Prof->BeginRecv();
#define ProfEndRecv()    Prof->EndRecv();
#define ProfBeginRead()    Prof->BeginRead();
#define ProfEndRead()      Prof->EndRead();
#define ProfBeginARead()    Prof->BeginARead();
#define ProfEndARead()      Prof->EndARead();
#define ProfBeginWrite()    Prof->BeginWrite();
#define ProfEndWrite()      Prof->EndWrite();
#define ProfBeginRemap()    if (Prof->getMode() == 1) Prof->BeginRemap();
#define ProfEndRemap()      if (Prof->getMode() == 1) Prof->EndRemap();

#else

#define ProfInit()       
#define ProfBegin(m)      
#define ProfEnd()       
#define ProfBeginSend() 
#define ProfEndSend()  
#define ProfBeginRecv()
#define ProfEndRecv() 
#define ProfBeginRead()
#define ProfEndRead() 
#define ProfBeginARead()
#define ProfEndARead() 
#define ProfBeginWrite()
#define ProfEndWrite() 
#define ProfBeginRemap()
#define ProfEndRemap() 

#endif

extern int runtimeDebug;


